import React from 'react'
//import bcrypt from 'bcrypt'

class UserList extends React.Component {
  constructor () {
    super()
    this.loadUser = this.loadUser.bind(this)
    this.saveUser = this.saveUser.bind(this)
    this.deleteUser = this.deleteUser.bind(this)
    this.clearUser = this.clearUser.bind(this)
    this.handleChange = this.handleChange.bind(this)

    this.state = { user: {
      _id: null,
      name: "",
      username: "",
      newPassword: ""
    }}
  }

  componentDidMount () {
    console.log('UserList did mount', this)
    const { getUserList } = this.props.usersActions
    getUserList()
  }

  loadUser (key, event) {
    this.setState({user: 
      { ...this.props.users.users[key], 
        newPassword: "",
        key
      }
    })
    console.log(this.state, this.props.users.users[key], this.state.user === this.props.users.users[key])
  }

  saveUser (key, event) {
    if (this.userid) {
      // Save existing user
    } else {
      // Add new user
    }
  }

  deleteUser (key, event) {
    console.log(key, event)
  }

  clearUser (event) {
    console.log(event)
    this.setState({user: {
      _id: null,
      name: "",
      username: "",
      newPassword: ""
    }})
  }

  handleChange (event) {
    console.log(this.name, this.name.value)
    this.setState({ 
      user: {
        ...this.state.user,
        name: this.name.value,
        username: this.username.value,
        newPassword: this.newPassword.value
      }
    })
  }

  render () {
    const state = this.props.users
    const actions = this.props.usersActions
    const { user } = this.state
    console.log('UserList', this)

    return (
      <div>
        <form>
          <h2>{(user._id) ? "Benutzer editieren" : "Neuer Benutzer"}</h2>
          {user._id ? <input type="hidden" key="userid" value={user._id} ref={(input) => {this.userid = input}} id="userid"/> : null}
          <label htmlFor="name">Name</label>
          <input type="input" ref={(input) => {this.name = input}} id="name" value={user.name} placeholder="Name" onChange={this.handleChange}></input>
          <label htmlFor="username">Benutzername</label>
          <input type="input" ref={(input) => {this.username = input}} id="username" value={user.username} placeholder="Benutzername" onChange={this.handleChange}></input>
          <label htmlFor="password">Passwort</label>
          <input type="password" ref={(input) => {this.newPassword = input}} id="new_password" value={user.newPassword} placeholder="Neues Passwort" onChange={this.handleChange}></input>
          <input type="submit" value={this.state.user._id ? "Aenderungen speichern" : "Benutzer anlegen"} onClick={(event) => this.loadUser(this.state.user.key, event)} />
          <input type="reset" value={this.state.user._id ? "Abbrechen" : "Loeschen"} onClick={(event) => this.clearUser(event)} />
        </form>
        <input type="button" onClick={actions.getUserList} value="Aktualisieren" />
        <table className='table table-bordered table-striped'>
          <thead>
            <tr>
              <th>Name</th><th>Benutzername</th><th>Aktionen</th>
            </tr>
          </thead>
          <tbody>
            {state.users ? state.users.map((user, key) => 
            <tr key={key}>
              <td>{user.name}</td>
              <td>{user.username}</td>
              <td>
                <a onClick={(event) => this.loadUser(key, event)}>editieren</a>
                <a onClick={(event) => this.deleteUser(key, event)}>loeschen</a>
              </td>
            </tr>
            ) : ""}
          </tbody>
        </table>
      </div>
    )
  }
}

export default UserList
